#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using vll = vector<ll>;
using pll = pair<ll, ll>;
#define sz(x) ((ll)(x).size())
#define For(i, a, n) for(ll i = a; i < (ll)(n); i++)
const ll MOD = 1e9+7;

template<typename T>
ostream& operator<<(ostream &os, const vector<T> &cont) {
    for (auto it = cont.begin(); it != cont.end(); ++it)
        os << (it == cont.begin() ? "" : " ") << *it;
    return os;
}

template<typename T1, typename T2>
ostream& operator<<(ostream &os, const pair<T1, T2> &cont) {
    os << "(" << cont.first << ", " << cont.second << ")";
    return os;
}

void print(ll sum_odd) {
    cout << (sum_odd % 2 ? "odd" : "even") << "\n";
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    ll N, M;
    cin >> N >> M;

    vll xs(N);
    vector<ll> positions={0};
    ll x;
    cin >> x;
    vll mul_even={x % 2 == 0};
    For(i, 1, N) {
        ll x; string op;
        cin >> op >> x;
        xs[i] = x % 2 == 0;
        if (op == "+" || op == "-") {
            mul_even.push_back(0);
        }
        ll pos = sz(mul_even) - 1;
        positions.push_back(pos);
        mul_even[pos] += x % 2 == 0;
    }
    ll sum_odd = 0;
    for (ll x: mul_even)
        sum_odd += x == 0;
    
    print(sum_odd);
    // cerr << sum_odd << " } " << mul_even << endl;
    For(qi, 0, M) {
        ll i, x;
        cin >> i >> x;
        --i;
        ll pos = positions[i];
        ll was = mul_even[pos];
        mul_even[pos] -= xs[i];
        xs[i] = x % 2 == 0;
        mul_even[pos] += xs[i];
        if (!was && mul_even[pos])
            sum_odd -= 1;
        if (was && !mul_even[pos])
            sum_odd += 1;
        print(sum_odd);
        // cerr << sum_odd << " } " << mul_even << endl;
    }
}